\ import shared Be libraries

.( Loading Be shared libraries support...)

variable LIB-LINK   lib-link off

INTERNAL

: link-symbol { lib sym \ temp$ -- }
    32 localalloc: temp$
    sym body> >name nfa-count temp$ place
    0 temp$ count + c!
    sym body> cell+  5
    temp$ 1+
    lib @ get_img_symbol abort" Imported symbol not found" ;

variable cookie

: link-lib ( ad -- ) { \ imginfo -- }
    dup 3 cells+
    ." Linking against " dup count type cr
    1076 malloc to imginfo
    cookie off
    count
    begin
      imginfo cookie 0 get_img_info
    0= while
      imginfo 36 + zcount 2over compare
    0= until
      2drop  imginfo @
    else
\      ." AS ADDON"
      drop load_add_on
    then
    imginfo release
    ?dup 0= abort" Library not found"
    over !
    dup 2 cells+ begin @ ?dup while 2dup cell- link-symbol repeat drop ;

EXTERNAL

: IMPORTLIB ( ad n -- )
    create here >r
    0 ,  lib-link link,  0 ,  s,
    r> link-lib ;

: IMPORT( ( lib -<argtypes name type>- )
    0 0
    begin
      bl parse 2dup s" )" compare over 0<> and
    while
      drop s" d^i"  rot c@ scan nip
      dup 0= abort" invalid function argument type"
      1 over 3 = - >r
      swap 2 lshift or
      r> under+
    repeat 2drop
    swap 9 > abort" Too many arguments, only 10 cells allowed"
    2 lshift
    header
    bl parse 0= abort" import function type missing"
    s" d^iv"  rot c@  scan  dup 0= abort" invalid function type"
    1- nip ( lib args outtype )
    or  dup 48 and
    if 30 cells ,
    else dup  14 + cells ,
    then
    0 , here >r
    ( lib args ) ,
    dup 2 cells+ link,
    r> link-symbol ;

: .LIBS
    lib-link
    begin @ ?dup while
      dup cell- body> .name
    repeat cr ;

: .LIB
    2 cells+
    begin @ ?dup while
      dup cell- body> .name
    repeat cr ;

: INIT-LIBS
    lib-link dup @
    if
      begin @ ?dup while
        dup cell- link-lib
      repeat cr
    else drop then ;

MODULE

initialization-chain chain-add init-libs
0 #if
 s" /boot/beos/system/lib/libroot.so" importlib libroot.so 

libroot.so import( int ) putchar void
libroot.so import( ) system_time double

\ libroot.so import( int int ^string ) printf void
\ 65 68 z" %c %d" printf cr

(* 68 putchar
system_time 2dup
system_time 2dup 2rot d- d.
system_time 2dup 2rot d- d.
system_time 2dup 2rot d- d.
system_time 2dup 2rot d- d.
system_time 2dup 2rot d- d.
system_time 2dup 2rot d- d.
system_time 2dup 2rot d- d. cr *)
#then
.( OK) cr
