here: kernel   portprims ,-t
9 c,-t 102 c,-t 107 c,-t 101 c,-t 114 c,-t 110 c,-t
101 c,-t 108 c,-t 46 c,-t 102 c,-t 0 c,-t align-t

32 constant bl
 4 constant cell
-4 constant -cell
 8 constant cfasize
0 constant 0
1 constant 1

255 constant maxstring
255 constant max-path
255 constant maxcounted

0 constant false
-1 constant true

: bounds
    over + swap ;
: chars ; immediate

: on ( ad -- )
    true swap ! ;
: off ( add -- )
    false swap ! ;

: char+ 1+ ;
 
: erase 0 fill ;
: blank bl fill ;

: min 2dup < if drop else nip then ;
: max 2dup < if nip else drop then ;
: umin 2dup u< if drop else nip then ;
: umax 2dup u< if nip else drop then ;
: 0max 0 max ;

: 3dup >r 2dup r@ -rot r> ;
: 4dup 2over 2over ;

: d= d- or 0= ;
: d0< 0< nip ;
: d< d- d0< ;
: d> 2swap d<  ;
: d<> d= 0= ;
: dmin 4dup d> if 2swap then 2drop ;
: dmax 4dup d< if 2swap then 2drop ;

: 0>= 0< 0= ;
: u>= u< 0= ;
: >= < 0= ;
: 0<= 0> 0= ;
: u<= u> 0= ;
: <= > 0= ;

: mod /mod drop ;
: */ */mod drop ;

variable sp0
variable rp0
variable handler
variable lp
variable op
variable base   10 base !-t
variable hld
variable msg

: depth
    sp0 @ sp@ - 2/ 2/ 1- ;

create pocket    maxstring allot-t
create cur-file    maxstring allot-t
create temp$    maxstring allot-t
create find-buffer    maxstring allot-t

15 constant #vocs
create context  #vocs cells-t reserve-t
variable current
variable last
variable last-link
variable voc-link

create loadfile kernel ,-t

284 constant icsize  \ 7 cells maxstring + aligned

create input-context 1988 allot-t
input-context value icp

: %source-id icp ;
: source-id icp @ ;
: loadline icp cell+ ;
: ?loading icp 2 cells+ ;
: >in icp 3 cells+ ;
: (source) icp 4 cells+ ;
: #tib (source) ;
: source (source) 2@ ;
: %source-position icp 6 cells+ ;
: source-position %source-position @ ;
: tib icp 7 cells+ ;

variable state
variable warning    true warning !-t
variable caps    true caps !-t

variable dp

: here dp @ ;
: allot dp +! ;
: , here ! cell allot ;
: w, here w! 2 allot ;
: c, here c! 1 chars allot ;
: aligned cell 1- + cell negate and ;
: align here aligned dp ! ;

: pad here 80 + ;

: "clip" maxcounted min 0max ;

: PLACE         ( addr len dest -- )
                SWAP "CLIP" SWAP
                2DUP 2>R
                CHAR+ SWAP MOVE
                2R> C! ;

: +PLACE        ( addr len dest -- )
                >R "CLIP" MAXCOUNTED R@ C@ - MIN R>
                2DUP 2>R
                COUNT CHARS + SWAP MOVE
                2R> C+! ;

: -trailing bl -trailchars ;
: -nulls 0 -trailchars ;

exec-vector output-vector
item emit
item type
item cr
item gotoxy
end-vector

output-vector stdout
stdout

' _emit is emit
' _type is type
' _cr   is cr
' _gotoxy is gotoxy

exec-vector input-vector
item key?
item key
item accept
end-vector

input-vector stdin
stdin

' _key is key
' _key? is key?

: upc ( char -- char )
    dup 96 > over 122 <= and if -33 and then ;
: upper ( ad len -- )
    bounds ?do
      i c@ upc i c!
    loop ;

: ?uppercase ( str -- str )
    caps @ if dup count upper then ;

: digit ( c base -- n flag )
    swap upc 48 - dup 0>= if
      dup 9 > if 7 - dup 10 < if nip false _exit then
      then
      dup rot <
    else nip false
    then ;

: >number ( ud addr len -- ud addr len )
    begin dup
    while >r dup>r c@ base @ digit
      if >r >r base @ um* r> base @ * + r> 0 d+ r> 1+
      else drop r> r> _exit
      then
      r> 1-
    repeat ;

0 value double?
-1 value dp-location

: number? ( ad len -- d f )
    false to double?
    -1 to dp-location
    over c@ [char] - =
    over 0> and dup>r
    if 1 /string then
    dup 0= if r>drop false _exit then
    0 0 2swap >number
    over c@ [char] . =
    over 0> and
    if dup 1- to dp-location
      1 /string >number
      dup 0= if true to double? then
    then nip 0=
    r> if >r dnegate r> then ;

exec-vector compile-vector
item literal immediate
item sliteral immediate
item (compile,)
end-vector

compile-vector threaded
threaded

defer compile,

' , is (compile,)

: compile
    r> lcount compile, >r ;

: skip   ( addr1 n1 char -- addr2 n2 )
    >r
    BEGIN dup
    WHILE over c@ r@ =
    WHILE 1 /string
    REPEAT  THEN r>drop ;

: scan ( ad1 n1 c -- ad2 n2 )
    >r
    begin dup
    while over c@ r@ <>
    while 1 /string
    repeat then r>drop ;

: (word) ( ad1 n1 c -- ad2 n2 )
    dup >r skip 2dup r> scan nip - ;

: parse-word ( c -- ad len )
    source 2dup >r >r >in @ over min /string
    rot dup bl = if drop (parse-white) else (word) then
    2dup + r> - 1+ r> min >in ! ;
: word ( c -- ad )
    parse-word pocket place pocket ;

: PARSE         ( char -- addr len )
    >R SOURCE >IN @ /STRING
    2DUP R> SCAN NIP -
    DUP 1+ >IN +! ;

: s,
    here over 1+ chars allot place 0 c, ;
: string,
    word count s, ;
: ,"
    [char] " string, align ;

: (c")
    r> dup count 1+ + aligned >r ;
: (z")
    r> count 1+ over + aligned >r ;
: (s")
    r> count 2dup 1+ + aligned >r ;
: (.")
    r> count 2dup 1+ + aligned >r type ;

defer new$  ' temp$ is new$

: ."
    compile (.") ," ; immediate

: catch
    sp@ >r
    handler @ >r
    rp@ handler !
    execute
    r> handler !
    r>drop
    0 ;

: throw
    ?dup
    if handler @ rp!
      r> handler !
      r> swap >r sp! drop r>
    then ;

: abort -1 throw ;

: (abort")
    if r> msg ! -2 throw then r> count 1+ + aligned >r ;

: abort"
    compile (abort") ," ; immediate

: ?missing ( f -- )
    abort" is undefined" ;

defer find-compare
' caps-comp is find-compare

: prepword ( str1 -- str2 )
    caps @ if
      count find-buffer place
      find-buffer ?uppercase
      ['] caps-comp
    else
      ['] compare
    then is find-compare ;

: (number) ( str -- d )
    count number? 0= ?missing ;
defer number  ' (number) is number

: space ( -- )
    bl emit ;

: spaces ( n -- )
    0max 0 ?do space loop ;

: decimal ( -- ) 10 base ! ;
: hex ( -- )     16 base ! ;
: binary ( -- )   2 base ! ;
: octal ( -- )    8 base ! ;

: hold ( char -- )
    hld @ 1- dup hld ! c! ;

: <# ( -- ) pad hld ! ;

: #> ( d1 -- ad len )
    2drop hld @ pad over - ;

: sign ( f -- )
    0< if [char] - hold then ;

: # ( d1 -- d2 )
    0 base @ um/mod -rot
    base @ um/mod -rot
    [char] 0 +
    dup [char] 9 > if 7 + then
    hold ;

: #S            ( d1 -- d2 )            BEGIN  #  2DUP OR 0= UNTIL ;
: (D.)          ( d -- addr len )       TUCK DABS  <# #S ROT SIGN #> ;
: D.            ( d -- )                (D.) TYPE SPACE ;
: D.R           ( d w -- )              >R (D.) R> OVER - SPACES TYPE ;
: (.)           ( n -- )                S>D  (D.) ;
: .             ( n -- )                S>D  D. ;
: .R            ( n w -- )              >R  S>D  R>  D.R ;
: U.            ( u -- )                0 D. ;
: U.R           ( u w -- )              0 SWAP D.R ;
: H.            ( u -- )                BASE @ SWAP  HEX U.  BASE ! ;
: ?             ( addr -- )             @ . ;

: .( [char] ) parse type ; immediate
: \ source >in ! drop ; immediate
: ( [char] ) parse 2drop ; immediate

: nfa-count ( ad1 -- ad2 len )
    dup c@ 63 and dup negate under+ ;
: >body cfasize + ;
: body> cfasize - ;
: >name cell- cell- 1- ;
: name> 1+ cell+ cell+ ;
: l>name cell- 1- ;
: n>link 1+ cell+ ;
: >link cell- ;
: link> cell+ ;
: vlink>voc cell+ ;
: voc>vlink cell- ;
: voc#threads 3 cells- @ ;
: vcfa>voc 5 cells+ ;
: voc>vcfa 5 cells- ;
: voc>srchfn cell- cell- ;
: >is >body ;

: .id ( nfa -- )
    nfa-count type space ;

: ?stack
    depth 0< abort" stack underflow" ;

: (literal)    ['] lit compile, , ;
' (literal) is literal

: _number,
    double? 0= if drop then
    state @
    if double? if swap [compile] literal then
      [compile] literal
    then ;

defer number,
' _number, is number,

: (;does)
    7 cells last @ name> r> over cell+ ! ! ;

: crash
    true abort" Deferred action undefined" ;

: link, ( addr -- )
    here over @ , swap ! ;

variable .smax   8 .smax !-t

: .S            ( -- )
    ?STACK
    DEPTH .SMAX @ MIN DUP
    IF ." [" DEPTH 1- 1 .R ." ] "
      BEGIN   DUP PICK 1 .R
        BASE @ 16 = IF ." h" THEN
        SPACE 1- DUP 0=
      UNTIL
    ELSE    ."  empty "
    THEN    DROP ;

: .name
    dup @ 2 cells =
    if dup cell+ @
      dup 0= if drop >name nfa-count type space else
      dup 2 = if drop 3 cells- @ body> recurse else
        drop ." XT(" (.) type ." ) "
      then then
    else >name nfa-count type space
    then ;

variable chain-link             \ linked list of chains

: new-chain     ( -- )
    create 0 , ['] noop , chain-link link, ;

: .chain        ( chain -- )
    dup @ 0=
    if drop ." Empty"
    else
      begin @ ?dup
      while dup cell+ @ .name
      repeat
    then    ;

: .chains       ( -- )          \ display the contents of all chains
    chain-link
    begin   @ ?dup
    while   dup 2 cells-
      cr dup body> .NAME ." --- " .chain
    repeat cr ;

: do-chain      ( chain_address -- )
    begin @ ?dup
    while dup>r cell+ perform r>
    repeat  ;

: do-until-chain      ( chain_address -- )
    false
    begin ?dup 0= while
      @ ?dup
    while
      dup>r cell+ perform r> swap
    repeat false else nip then ;

: noop-chain-add ( chain_address -- addr )      \ add chain item, return addr of cfa added
    begin dup @
    while @
    repeat here swap ! 0 , here ['] noop , ;

new-chain initialization-chain  \ chain of things to initialize
new-chain         unload-chain  \ chain of things to de-initialize
new-chain         forget-chain  \ chain of types of things to forget
new-chain      semicolon-chain  \ chain of things to do at end of definition
new-chain        number?-chain  \ chain of number conversion options
new-chain           find-chain  \ chain of word finding words
new-chain       compile,-chain  \ chain of xt compiling words

: do-;chain    ( -- )
                semicolon-chain do-chain ;

:noname compile,-chain do-until-chain drop ;  is compile,
:noname (compile,) true ;  add-to-chain compile,-chain

: dump ( a n -- )
    base @ >r hex
    0 ?do
      i 15 and 0= if cr dup 6 .r then  
      count 3 .r
    loop drop
    r> base ! ;

: search-1wordlist ( ad n thread-ad -- xt t | f )
    -rot 2>r
    begin @ ?dup 0= if r>drop r>drop false _exit then
      dup l>name nfa-count 2r@ find-compare 0=
    until r>drop r>drop dup link>
    swap l>name c@ 128 and if 1 else -1 then ;

: (voc-search)
    >r 2dup r@ voc#threads "#hash r> + search-1wordlist ;

: _search-wordlist
    dup voc>srchfn perform ;

: search-wordlist
    >r
    caps @ if
      find-buffer place
      find-buffer ?uppercase count
      ['] caps-comp
    else ['] compare
    then is find-compare
    r> dup voc>srchfn perform ;

: (find) ( str -- xt t | str f )
    dup c@ 0= if false _exit then
    context
    begin dup @
    while dup 2@ <>
      if over count  2 pick @ _search-wordlist ?dup
        if 2swap 2drop _exit then
      then cell+
    repeat drop false ;

: caps-find ( str -- xt t | str f )
    dup c@ 0= if false _exit then
    dup prepword >r
    context
    begin dup @
    while dup 2@ <>
      if r@ count  2 pick @ _search-wordlist ?dup
        if 2swap 2drop r>drop _exit then
      then cell+
    repeat drop r>drop false ;

: find ( str -- str f | xt +1/-1 )
    dup>r prepword
    find-chain do-until-chain
    ?dup 0= if drop r@ false then r>drop ;

: defined
    bl word find ;

: char
    bl word 1+ c@ ;

: [char]
    char [compile] literal ; immediate

: view,
    loadline @ , ;

: string,| ( addr n -- )
    align dup 1+ negate cell 1- and
    0 ?do 0 c, loop
    tuck 0 ?do count c, loop drop
    here last ! c, ;

: "name, ( ad n -- )
    dup 0= abort" need a name to create"
    caps @ if 2dup find-buffer place
      find-buffer count 2dup upper
      ['] caps-comp
    else 2dup ['] compare
    then is find-compare
    current @ _search-wordlist
    if drop warning @
      if cr ?loading @
        if ." From file: " cur-file count type
          ."  word: "
        then 2dup type ."  isn't unique "
      then
    then
    string,| ;

: _"header ( ad n -- )
    2dup 2>r "name, view,
    current @ dup 2r> rot voc#threads "#hash +
    dup last-link ! link, ;
defer "header    ' _"header is "header

: _header
    bl word count "header ;
defer header   ' _header is header

: create
    header 4 cells , 0 , ;

: variable
    [T] create 0 , ;

: constant
    header 5 cells , 0 , ( n ) , ;

VARIABLE CSP    \ Current Stack Pointer variable

: !CSP          ( -- )  \ save current stack pointer for later stack depth check
    SP@ CSP ! ;

: ?CSP          ( -- )  \ check current stack pointer against saved stack pointer
    SP@ CSP @ XOR ABORT" stack changed" ;

0 value parms

: parms-init
    0 to parms ;

variable all-exits

: res-exits ( -- )
    all-exits @
    begin dup while
      dup @ here rot !
    repeat
    all-exits ! ;

: exit
    compile branch all-exits link, ; immediate

defer parser

: interpreter ( xt f -- )
    drop execute ?stack ;

: compiler ( xt f -- )
    0> if execute else compile, then ;

: [ state off ['] interpreter is parser ; immediate
: ] state on  ['] compiler is parser ;

: hide
    last @ n>link @ last-link @ ! ;

: reveal
    last @ n>link last-link @ ! ;

: _nn;
    res-exits
    parms if compile unparm  0 to parms then
    compile unnest ;

: _;
    _nn; reveal ;

: :
    header hide 2 cells , 0 , ['] _; !csp [t] ] parms-init ;

: :noname
    align here 2 cells , 1 , ['] _nn; !csp [t] ] parms-init ;

: recurse
    ( ?comp ) last @ name> compile, ; immediate

: ;
    ?csp
    execute
    [compile] [ do-;chain ; immediate

: does>
    ['] (;does) compile, ; immediate

: immediate
    last @ dup c@ 128 or swap c! ;

: _interpret
   begin bl word dup c@
   while find ?dup
     if parser 
     else number number,
     then
   repeat drop ;

defer interpret
' _interpret is interpret

: interpret/compile:
    [t] create [t] immediate swap , , \ do not change, is-i/c? relies on that
    does> state @ if cell+ then perform ;

' noop dup interpret/compile: ['] immediate

: i/c>int   >body       @ ;
: i/c>comp  >body cell+ @ ;

: is-i/c? ( xt -- flag )
    cell+ @ [ ' interpret/compile: 8 cells+-t ] literal = ;

: '
    defined 0= ?missing
    dup is-i/c? if i/c>int then ;

' ' ' ['] >body-t !-t
:noname ' [compile] literal ;  ' ['] >body-t 1 cells+-t  !-t

: comp'
    defined ?dup 0= ?missing
    over is-i/c? if swap i/c>comp swap swap then ;

: postpone
    comp' 0< if compile compile then compile, ; immediate

: [compile]
    comp' drop compile, ; immediate

: defer
    header 6 cells , 0 , ['] crash , ;

:noname [t] ' dup @ 7 cells =
    if >body dup lcount @ swap @ +
    else >body then ; temp!
:noname temp ! ;
:noname temp [compile] literal compile ! ;
interpret/compile: is immediate

: value
    header 8 cells , 0 , , 9 cells , 10 cells , ;

:noname [t] ' >body cell+ ; temp!
:noname temp execute ;
:noname temp compile, ;
interpret/compile: to immediate

:noname [t] ' >body 2 cells+ ; temp!
:noname temp execute ;
:noname temp compile, ;
interpret/compile: +to immediate

:noname [t] ' >body ;
:noname [t] ' >body [compile] literal ;
interpret/compile: &of immediate

:noname [char] " word
      new$ dup>r over c@ 1+ move  r> ; temp!
:noname temp count ;
:noname compile (s") ," ;
interpret/compile: s" immediate

temp@
:noname compile (c") ," ;
interpret/compile: c" immediate

:noname temp count over + 0 swap c! ;
:noname compile (z") ," ;
interpret/compile: z" immediate

: chain-add     ( chain_address -<word_to_add>- )       \ for normal forward chains
    begin   dup @
    while   @
    repeat  here  0 ,  [t] ' ,  swap ! ;

: add-to-chain     ( xt -<chain>- )       \ for normal forward chains
    [t] ' >body
    begin   dup @
    while   @
    repeat  here  0 ,  rot ,  swap ! ;

: chain-add-before ( chain_address -<word_to_add>- )    \ for reverse chains like BYE
    here over @ , [t] ' , swap ! ;

: (accept) ( ad n -- len )
    >r 0
    begin dup r@ <
    while 2dup + key
      dup 10 -
    while dup 8 =
      if emit  bl emit 8 emit  drop
        1- 0max
      else dup emit
        swap c!  1+
      then
    repeat
      2drop
    then
    nip  r> drop ;

' (accept) is accept

0 value cur-handle
0 value _read-line-len
0 value not-end?

: read-line ( ad len fileid -- len flag ior )
    >r                           \ save the fileid
    0max dup to _read-line-len
    1+ 2dup r@ read-file ?dup    \ read requested chars+2
    if r>drop >r drop 2drop 0 -1 r> _exit then   \ ior <> 0 = error
    2dup = to not-end?  min dup  \ if read ANY characters
    if _read-line-len min to _read-line-len
      _read-line-len 10 scan dup \ look for LF
      if _read-line-len over - to _read-line-len  1 /string then \ remove it
      dup
      if nip                     \ -- length_remaining
        r@ file-position 2drop   \ -- remainder current_filepos
        swap -                   \ actual position+1
        not-end?                 \ only if we read what we
        if 1- 0max               \ backup one to correct
        then    0                \ new current ud
        r@ reposition-file drop
      else 2drop then r>drop
      _read-line-len -1 0
    else 2drop r>drop            \ discard fileid
      0 0 0                      \ return 0=len, eof=false ior=false
    then    ;

VARIABLE ECHO

: start/stop ;

: ?.REFILL      ( -- )
    ECHO @
    IF CR SOURCE TYPE
      START/STOP
    THEN    ;

DEFER .REFILL   ' ?.REFILL IS .REFILL

0 value len-prev

: QUERY         ( -- )          \ accept a line of input from the user to TIB
    TIB DUP MAXSTRING ACCEPT (SOURCE) 2!
    >IN OFF
    0 %SOURCE-ID ! 0 %SOURCE-POSITION ! ;

: REFILL        ( -- f )        \ refill TIB from current input stream
    SOURCE-ID ?DUP
    IF 1+  ( not from evaluate )
      IF LOADLINE INCR
        TIB DUP MAXSTRING
        len-prev %source-position !
        SOURCE-ID READ-LINE ABORT" read error"
        IF  dup 1+ to len-prev
          (SOURCE) 2!
          >IN OFF
          .REFILL
          TRUE _EXIT
        THEN 0 to len-prev 2DROP
      THEN FALSE _EXIT
    THEN CR QUERY TRUE ;

: LINKFILE      ( a1 -- ) \ link name a1 as current file IF LOADING ONLY !!
    ?LOADING @
    IF loadfile @ cell+ count + aligned here =
      if loadfile @ dup dp ! @ loadfile ! then
      LOADFILE LINK,
      COUNT HERE PLACE
      HERE C@ 1+ ALLOT align
    ELSE DROP THEN ;

DEFER STACK-CHECK       ' NOOP   IS STACK-CHECK

VARIABLE START-LINE
FALSE VALUE INCLUDING?

: >LINE         ( n1 -- )     \ move to line n1, 1 based
                1- 0MAX ?DUP IF  0 DO  REFILL DROP  LOOP THEN ;

: DO-INCLUDE    ( -- )
                INCLUDING? >R
                TRUE TO INCLUDING?
                START-LINE @ >LINE
                START-LINE OFF
                len-prev  >r 0 to len-prev
                BEGIN   REFILL
                        INCLUDING? AND
                WHILE   INTERPRET
                        STACK-CHECK
                REPEAT
                r> to len-prev
                R> TO INCLUDING? ;

DEFER START-INCLUDE     ' NOOP IS START-INCLUDE
DEFER   END-INCLUDE     ' NOOP IS   END-INCLUDE

: INCLUDE-FILE  ( fileid -- ) \ load file open on "fileid" to current dictionary
    icsize +to icp
    %source-id !
    ?loading on
    loadfile @ >r
    pocket linkfile
    loadline off
    0 %source-position !
    start-include
    ['] do-include catch
    source-id close-file drop
    end-include
    throw
    align
    icsize negate +to icp
    r> linkfile
    ?loading @
    if loadfile @ cell+ count "clip" cur-file place then ;

: bin ;
: r/o s" rb" drop ;
: w/o s" wb" drop ;

create defext$ 1 c,-t 102 c,-t 0 c,-t  5 allot-t

: defext
    bl word count 6 min defext$ place ;

create openbuf maxstring allot-t

: "to-pathend" ( a1 n1 -- a2 n2 )
    begin 2dup [char] / scan ?dup
    while 2swap 2drop 1 /string
    repeat drop ;

: ?defext ( ad -- )
    dup count "to-pathend" [char] . scan nip 0=
    defext$ c@ and
    if >r s" ." r@ +place
      defext$ count r@ +place r>
    then drop ;

: _"open ( a n -- fileid f )
    openbuf place
    openbuf count r/o bin open-file dup
    if 2drop
      openbuf ?defext
      openbuf count r/o bin open-file
    then
    dup 0= if openbuf count cur-file place then
    openbuf count pocket place ;

defer "open  ' _"open is "open

: $open count "open ;

: INCLUDED      ( addr len -- )   \ load file addr,len into current dictionary
                "OPEN ABORT" file not found"  INCLUDE-FILE ;

: FLOAD         ( -<filename>- )  \ load "filename" into application dictionary
                BL WORD COUNT INCLUDED ;

: INCLUDE       ( -<filename>- )  \ load "filename" into application dictionary
                FLOAD ;

: OK            ( -- )
                CUR-FILE COUNT INCLUDED ;

: \S            \ comment to end of file
                FALSE TO INCLUDING?  [COMPILE] \ ; IMMEDIATE

defer hello

: %hello
    ." Portable Forth for BeOS 0.2" cr
    ." (c) Martin Läuter, thanks to Tom Zimmer" cr ;

' %hello is hello

: ?EXEC  STATE @    ABORT" execution only"    ;
: ?COMP  STATE @ 0= ABORT" compilation only"  ;

variable all-leaves
: leave  compile unloop compile branch  all-leaves link, ; immediate
: ?leave  compile ?branch here 4 cells + , [compile] leave ; immediate

: res-leaves ( ad -- )
    all-leaves @
    begin ?dup while
      dup @ here rot !
    repeat
    all-leaves ! ;

: do ?COMP compile _do
    all-leaves @  here ; immediate
: ?do ?COMP compile _?do
    all-leaves @  here 0 , ; immediate
: (resloop)
    dup @ if , else dup cell+ , here swap ! then
    res-leaves ;
: loop ?COMP compile _loop (resloop) ; immediate
: +loop ?COMP compile _+loop (resloop) ; immediate
: begin ?COMP compile _begin  here ; immediate
: while ?COMP compile _while  here 0 , swap ; immediate
: repeat ?COMP compile _repeat  , here swap ! ; immediate
: until ?COMP compile _until  , ; immediate
: again ?COMP compile _again  , ; immediate
: if ?COMP compile _if  here 0 , ; immediate
: else ?COMP compile _else  here 0 , here rot ! ; immediate
: then ?COMP compile _then  here swap ! ; immediate
: ahead ?comp compile _ahead here 0 , ; immediate

: case 0 ; immediate
: of compile _of here 0 , ; immediate
: endof compile _endof here 0 , here rot ! ; immediate
: endcase
    compile _endcase
    begin ?dup while
      here swap !
    repeat ; immediate

: (sliteral)
    compile (s") dup c,
    0 ?do count c, loop drop 0 c, align ; immediate
' (sliteral) is sliteral

: r/w s" wb" drop ;

: save-system ( -- )
    bl word count r/w open-file abort" Open error" >r
    0 here r@ write-file abort" Write error"
    r> close-file drop ;

: alias
    [t] create ,
    does> perform ;

: (new-vector)
    [t] create >body dup , cell+ @ cells allot
    does> lcount ! ;

: exec-vector ( -<name>- ad 0 )
    [t] create here 0 , 0 , 0
    does> (new-vector) ;
: item ( ad n -- ad n+1 )
    [t] create over , dup cells , 1+ 
    does> 2@ @ + perform ;
: end-vector ( ad n -- )
    swap cell+ ! ;

: _message ( n -- )
    base @ >r decimal
    cr ." Error: "
    pocket count type space
    dup -2 =
    if drop msg @ count type
    else ." Error # " .
    then
    ?loading
    if cr ." File: " loadfile @ cell+ count type
      ."  at line: " loadline ?
    then
    r> base ! ;

defer message
' _message is message

: QUERY-INTERPRET   ( -- )
    QUERY SPACE INTERPRET ;

: _RESET-STACKS ( ?? -- )
                SP0 @ SP! ;

DEFER RESET-STACKS   ' _RESET-STACKS IS RESET-STACKS

: _QUIT         ( -- )
    RP0 @ RP!
    BEGIN   [COMPILE] [
      ?LOADING OFF
      BEGIN   CR ['] QUERY-INTERPRET CATCH  ?DUP 0=
      WHILE   STATE @ 0=
        IF      ."  ok"
          DEPTH .SMAX @ MIN 0
          ?DO  [CHAR] . EMIT  LOOP
        THEN
      REPEAT
      DUP 1+          \ no message on abort
      IF MESSAGE THEN
      RESET-STACKS    \ reset the stacks
    AGAIN ;
DEFER QUIT              ' _QUIT         IS QUIT

: EVALUATE      ( addr len -- ) \ interpret string addr,len
    icsize +to icp
    (SOURCE) 2!
    >IN OFF
    -1 %SOURCE-ID !
    0 %SOURCE-POSITION !
    ['] INTERPRET CATCH
    THROW
    icsize negate +to icp ;

0 local local0
1 local local1
2 local local2
3 local local3
4 local local4
5 local local5
6 local local6
7 local local7
8 local local8
9 local local9

10 constant #-locals

create local-ptrs
' local0 ,-t ' local1 ,-t ' local2 ,-t ' local3 ,-t ' local4 ,-t
' local5 ,-t ' local6 ,-t ' local7 ,-t ' local8 ,-t ' local9 ,-t

0 VALUE INPARMS         \ number of input paramters
0 VALUE LOCFLG          \ 1 = compiling args, 0 = compiling locals

create parmlist 128 allot-t

: ADDPARM       ( addr cnt -- ) \ add string to end of parmlist
    1 +TO PARMS
    PARMS #-LOCALS > ABORT" Too many parameters"
    parmlist parms 1 ?do count + loop
    place ;

: PARMS,        ( -- )   \ compile runtime to push parameters
    COMPILE INIT-LOCALS     \ else this is a normal local def
    INPARMS PARMS OVER - w, ( #locals ) w, ( #args ) ;

: (LOCAL)       ( addr cnt -- )
    DUP 0= IF 2DROP ELSE ADDPARM  LOCFLG +TO INPARMS  THEN ;

: {             ( -- )  \ begin local variable usage in the form;
                        \ { initedloc1 initedloc2 \ uninitedloc3 -- comments }
    ?COMP
    PARMS ABORT" Locals may be defined only once per definition."
    0 TO INPARMS
    1 TO LOCFLG
    BEGIN   BL WORD ?UPPERCASE COUNT \ tjz per 'smb' March 6th, 1996
      over c@ DUP [CHAR] - <>        \ as in { name -- }
      SWAP [CHAR] ' <> AND    \ or as { name 'name' -- }
    WHILE   over c@ [CHAR] \ =  \ start of non-initialized
                                \ local variables as in
                                \ { name \ another -- }
      IF      0 TO LOCFLG 2DROP
      ELSE    over c@ [CHAR] } = ABORT" Args missing --"
        (LOCAL)
      THEN
    REPEAT  2DROP
    PARMS 0>
    IF      PARMS,  ( compile runtime code )
    THEN
    BEGIN   BL WORD DUP C@ 0= ABORT" Args missing }"
      1+ c@ [CHAR] } =
    UNTIL   ; IMMEDIATE

: pfind ( str -- str f | cfa -1 )
    state @ 0= parms 0<= or if false _exit then
    dup count 2>r
    parmlist parms
    begin dup
    while 1- swap count 2dup 2r@ find-compare
    while + swap
    repeat
      2drop nip
      local-ptrs +cells @ -1
    else nip then
    r>drop r>drop ;

find-chain chain-add pfind
find-chain chain-add (find)

: localalloc:
    parms 0= abort" needs local variables"
    compile localalloc [t] to ; immediate

: H s" hex" evaluate bl word count evaluate s" decimal" evaluate ; immediate

: argv 6 cells @ ;
: argc 5 cells @ ;

defer on_args
:noname  argv cell+ @ zcount evaluate ;  is on_args

create first-file
6 c,-t 101 c,-t 120 c,-t 116 c,-t 101 c,-t 110 c,-t 100 c,-t 0 c,-t
12 allot-t

: firstfile: bl word count first-file place ;

: forth-io
    stdin stdout threaded ;

initialization-chain chain-add forth-io

: (bye)
    unload-chain ['] do-chain catch
    ?dup if dup 1+ if message cr _bye then
    then
    cr _bye ;

defer bye  ' (bye) is bye

: cold
    sp@ sp0 !
    rp@ cell+ rp0 !
    ['] forth vcfa>voc dup context ! current !
    [compile] [
    input-context to icp
    initialization-chain ['] do-chain catch
    ?dup if dup 1+ if message cr (bye) then drop
    then
    argc 1 >
    if ['] on_args
    else hello
      first-file count ?dup
      if ['] included
      else drop quit
      then
    then catch
    ?dup if dup 1+ if message then then
    (bye) ;

