\ first version of target compiler

only forth also

vocabulary host
vocabulary target
root definitions
' host alias host
' target alias target
\ ' only alias only
\ ' also alias also
' definitions alias definitions
' fload alias fload
' words alias words
: [h] also host ' compile, previous ; immediate

forth definitions

variable primcnt  1 primcnt !

create target-area 65536 allot
0 value target-origin

4 constant cell-t
: cells-t cell-t * ;

157 constant #threads-t

variable dp-t  0 dp-t !
: here-t   dp-t @ ;

: aligned-t  cell-t 1- + cell-t negate and ;
: align-t here-t aligned-t dp-t ! ;

: allot-t dp-t +! ;

\ : le!
\       over 24 rshift over c!
\    1+ over 16 rshift over c!
\    1+ over  8 rshift over c!
\    1+ c! ;

\ : le@
\     count 24 lshift swap
\     count 16 lshift under+
\     count  8 lshift under+
\     c@              + ;

: le! ! ;   : le@ @ ;
\ : le! 2dup c!
\    1+ over  8 rshift over c!
\    1+ over 16 rshift over c!
\    1+ swap 24 rshift swap c! ;

\ : le@
\     count           swap
\     count  8 lshift under+
\     count 16 lshift under+
\     c@    24 lshift + ;

: there target-origin - target-area + ;
: @-t there le@ ;
: !-t there le! ;
: c@-t there c@ ;
: c!-t there c! ;
: ,-t align-t here-t !-t cell-t allot-t ;
: c,-t here-t c!-t  1 allot-t ;
: reserve-t here-t there over erase allot-t ;
: >body-t 2 cells-t + ;

variable last-link-t
variable last-t
variable state-t
variable voc-link-t
variable chain-link-t
variable current-t
variable all-leaves-t
variable ic-link
variable temp-t
0 value lastxt-t

: link,-t
    here-t over @ ,-t swap ! ;

: "#hash-t ( ad n #thr -- off )
    >r dup
    begin ?dup
    while 1- -rot >r
      count upc r> dup 7 lshift swap 25 rshift or + rot
    repeat nip 0 r> um/mod drop cells-t ;
  
: find-t ( ad n -- xt-t )
    drop 1-
    also target find previous 0= abort"  Target word not found"
    >body @ ;

: [t'] ( -- xt-t )
    bl word count postpone sliteral
    compile find-t ; immediate

: t'
    bl word count find-t ;

: header-t
    align-t
    bl word count dup 1+ negate 3 and
    0 ?do 0 c,-t loop
    2dup #threads-t "#hash-t >r
    tuck 0 do dup c@ upc c,-t char+ loop drop
    here-t last-t !  c,-t
    loadline @ ,-t
    current-t @ r> + dup last-link-t !
    dup @-t here-t rot !-t  ,-t ;

: compile,-t ( xt-h -- )
    ,-t ;

: literal-t ( n -- )
    [t'] lit compile,-t ,-t ; immediate

: number,-t ( d -- )
    drop state-t @
    if [compile] literal-t then ;

: interpret-t ( -- )
    begin bl word dup c@
    while find ?dup
      if state-t @ =
        if >body @ compile,-t
        else execute
        then
      else number number,-t
      then
    repeat drop ;

: recreate ( cfa1 cfa2 -- )
    >in @ >r
    create
    r> >in !
    header-t
    here-t dup ,  to lastxt-t
    swap cells-t ,-t cells-t ,-t ;

: ksave ( -- )
    bl word count r/w bin open-file abort" Cannot create file"
    >r target-area here-t target-origin - r@ write-file abort" Cannot write file"
    r> close-file abort" Close failed" ;

: (new-vector)-t
    7 0 recreate @ >body-t dup ,-t cell-t + @-t cells-t allot-t
    does> @ >body-t dup @-t cell-t under+ !-t ;

: res-leaves-t ( ad -- )
    all-leaves-t @
    begin ?dup while
      dup @-t here rot !-t
    repeat
    all-leaves-t ! ;

: res-ic
    ic-link @
    begin ?dup while
      dup @-t [t'] interpret/compile: 8 cells+ rot !-t 2 rshift
    repeat ;

: (resloop)-t
    dup @-t if ,-t else dup cell-t + ,-t here-t swap !-t then
    res-leaves-t ;

host definitions forth

: switch
    ['] interpret-t is interpret ;
: switch-back
    ['] _interpret is interpret ;

: prim ( -- )
    primcnt @ 0 recreate
    1 primcnt +! ;

: : ( -- )
    2  0 recreate
    state-t on
    does> true abort" Cannot execute target word" ;

: ; ( -- )
    [t'] unnest compile,-t
    state-t off ; immediate

: immediate
    last-t @ dup c@-t 128 or swap c!-t ;

: variable
    4  0 recreate
    0 ,-t
    does> @ >body-t ;

: create
    4  0 recreate
    does> @ >body-t ;

: constant
    5  0 recreate
    ,-t
    does> @ >body-t @-t ;

: defer
    6  0 recreate
    0 ,-t
    does> true abort" Cannot execute target deferred word" ;

: value
    8  0 recreate
    ,-t
    9 cells-t ,-t 10 cells-t ,-t
    does> @ @-t ;

: local
    11  0 recreate
    1+ cells negate ,-t
    12 cells-t ,-t 13 cells-t ,-t
    does> true abort" Cannot execute local" ;

: #vocabulary
    7 0 recreate
    dup ,-t  0 ,-t  voc-link-t link,-t
    here-t current-t !
    0 ?do 0 ,-t loop ;

: interpret/compile:
    7 ic-link @ recreate here-t cell-t - ic-link !
    swap ,-t ,-t ;

: :noname
    here-t  dup to lastxt-t
    2 cells-t ,-t 1 ,-t state-t on
    does> true abort" Cannot execute target word" ;

: new-chain
    [H] create
    0 ,-t  [t'] noop ,-t chain-link-t link,-t ;

: chain-add
    begin   dup @-t
    while   @-t
    repeat
    here-t
    0 ,-t  t' ,-t  swap !-t ;

: add-to-chain
    t' >body-t
    begin   dup @-t
    while   @-t
    repeat
    here-t
    0 ,-t  rot ,-t  swap !-t ;

: leave  [t'] branch compile,-t  all-leaves-t link,-t ; immediate
: ?leave  [t'] ?branch compile,-t  all-leaves-t link,-t ; immediate

: do [t'] _do compile,-t
    all-leaves-t @  here-t ; immediate
: ?do [t'] _?do compile,-t
    all-leaves-t @  here-t 0 ,-t ; immediate
: loop [t'] _loop compile,-t (resloop)-t ; immediate
: +loop [t'] _+loop compile,-t (resloop)-t ; immediate
: begin [t'] _begin compile,-t here-t ; immediate
: while [t'] _while compile,-t here-t 0 ,-t swap ; immediate
: repeat [t'] _repeat compile,-t ,-t here-t swap !-t ; immediate
: until [t'] _until compile,-t ,-t ; immediate
: again [t'] _again compile,-t ,-t ; immediate
: if [t'] ?branch compile,-t here-t 0 ,-t ; immediate
: else [t'] _else compile,-t here-t 0 ,-t here-t rot !-t ; immediate
: then [t'] _then compile,-t here-t swap !-t ; immediate

: recurse
    lastxt-t compile,-t ; immediate

: does>
    [t'] (;does) compile,-t here-t ; immediate

' !-t alias !-t
' @-t alias @-t
' >body-t alias >body-t
' allot-t alias allot-t
' align-t alias align-t
' reserve-t alias reserve-t
' ,-t alias ,-t
' c,-t alias c,-t
' cells-t alias cells-t
: order order also target words previous cr ;
:noname cells-t + ; alias cells+-t
: [ state-t off ; immediate
: ] state-t on ;
' literal-t alias literal immediate
: temp temp-t @ compile,-t ; immediate
: temp! temp-t ! ;
: temp@ temp-t @ ;

: ' ( -- xt )
    state-t @
    if [t'] ' compile,-t
    else t' then ; immediate

: is ( xt -- )
    t' dup @-t 7 cells =
    if >body-t dup @-t @-t swap cell-t + @-t +
    else >body-t then
    state-t @
    if [compile] literal-t [t'] ! compile,-t
    else !-t then ; immediate

: link-forth
    last-t @ 1+ cell-t + ( n>link-t )
    s" FORTH" #threads-t "#hash-t
    current-t @ + !-t ;

: ( ')' parse 2drop ; immediate
: \ source nip >in ! ; immediate

: [char] bl word 1+ c@ postpone literal-t ; immediate

: abort" [t'] (abort") compile,-t
    [char] " parse dup c,-t 0 ?do count c,-t loop drop 0 c,-t align-t ; immediate

: [compile]
    t' compile,-t ; immediate

: [']
    t' postpone literal-t ; immediate

: to
    t' >body-t cell-t + compile,-t ; immediate

: +to
    t' >body-t 2 cells-t + compile,-t ; immediate

: s"
    [t'] (s") compile,-t
    [char] " word count dup c,-t
    0 ?do count c,-t loop drop 0 c,-t align-t ; immediate
: ."
    [t'] (.") compile,-t
    [char] " word count dup c,-t
    0 ?do count c,-t loop drop 0 c,-t align-t ; immediate

: [T]
    t' compile,-t ; immediate

: exec-vector ( -<name>- ad 0 )
    7 0 recreate here-t 0 ,-t 0 ,-t 0
    does> (new-vector)-t ;
: item ( ad n -- ad n+1 )
    7 0 recreate over ,-t dup cells-t ,-t 1+  ;
: end-vector ( ad n -- )
    swap cell-t + !-t ;

: here:
    create here-t ,
    does> @ ;

hex abba51de decimal ,-t \ magic
0 ,-t
400000 ,-t \ memory
4096 ,-t \ stack size
4096 ,-t \ rstack size
20000 current-t !
0 ,-t \ argc
0 ,-t \ argv

only target also definitions
host
switch
fload portprims.f
fload fkernel.f
switch-back

only forth also definitions

\ items
dup t' literal cell-t + !-t
dup t' sliteral cell-t + !-t
dup t' (compile,) cell-t + !-t
dup t' emit cell-t + !-t
dup t' type cell-t + !-t
dup t' cr cell-t + !-t
dup t' gotoxy cell-t + !-t
dup t' key? cell-t + !-t
dup t' key cell-t + !-t
t' accept cell-t + !-t

\ exec-vectors
dup t' output-vector cell-t + !-t
dup t' input-vector cell-t + !-t
t' compile-vector cell-t + !-t

\ vectors
dup t' stdout cell-t + !-t
dup t' stdin cell-t + !-t
t' threaded cell-t + !-t

\ aliases
drop

here-t t' dp >body-t !-t
t' cold 1 cells-t !-t
voc-link-t @  t' voc-link >body-t !-t
t' (voc-search)  t' forth >body-t cell-t + !-t
chain-link-t @  t' chain-link >body-t !-t

res-ic

.( Statistics: ) cr
.( Origin:            0x) target-origin h. cr
.( Kernel size:       0x) here-t target-origin - dup h. .( = ) . .( Bytes) cr
.( Nr. of primitives: ) primcnt @ . cr

ksave Kernel