.( Loading utility words ... )

defer "message     ' 2drop is "message

: roll ( )
    dup 1+ pick >r
    sp@ cell+ dup cell+ rot cells move drop r> ;

: d0=  or 0= ;

: ?exit
    postpone if postpone _exit postpone then ; immediate

: new-number?   ( a1 n1 f1 -- d1 TRUE | a1 n1 FALSE )
                dup ?exit drop
                2dup number?
                if      2swap 2drop TRUE
                else    2drop FALSE
                then    ;

number?-chain chain-add new-number?             \ first item in NUMBER? chain

: supnum? ( ad n fl -- d t | ad n f )
    ?dup if exit then
    2dup 2>r
    over c@ dup [char] ' =
    if drop over 2 + c@ [char] ' = over 3 = and
      if drop char+ c@ 0 true
      else false
      then
    else dup [char] $ = dup rot [char] % = or
      if base @ >r
        if hex else binary then
        1 /string number?
        r> base !
      else drop
        over count [char] 0 = swap c@ 32 or [char] x = and
        if base @ >r hex
          2 /string number?
          r> base !
        else number? then
      then
    then
    ?dup if r>drop r>drop else 2drop 2r> false then ;

number?-chain chain-add supnum?

: super-number? ( a1 n1 -- d f1 )
    FALSE to double?
    FALSE number?-chain do-chain ;

: new-number    ( ^str -- d )           \ an extensible version of NUMBER
    count super-number? 0= ?missing ;

' new-number is number                  \ replace normal number conversion
                                        \ with the new chain scheme

defer discard-number
   ' 2drop is discard-number
 
: synonym
    create defined dup 0= ?missing
      0> if immediate then ,
    does> perform ;

\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\       various number display words
\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

\ double number display with commas

: (xUD,.)       ( ud commas -- a1 n1 )
                >r
                <#                      \ every 'commas' digits from right
                r@ 0 DO # 2DUP D0= ?LEAVE LOOP
                BEGIN   2DUP D0= 0=     \ while not a double zero
                WHILE   [char] , HOLD
                        r@ 0 DO # 2DUP D0= ?LEAVE LOOP
                REPEAT  #> r> drop ;

: (UD,.)        ( ud -- a1 n1 )
                base @             \ get the base
                dup  10 =          \ if decimal use comma every 3 digits
                swap  8 = or       \ or octal   use comma every 3 digits
                4 + (xUD,.) ;      \ display commas every 3 or 4 digits

: UD,.R         ( ud l -- )        \ right justified, with ','
                >R (UD,.) R> OVER - SPACES TYPE ;

: U,.R          ( n1 n2 -- )       \ display double unsigned, justified in field
                0 SWAP UD,.R ;

: UD.           ( ud -- )          \ display double unsigned
                0 UD,.R ;

: UD.R          ( ud l -- )        \ right justified, WITHOUT ','
                >R 16 (xUD,.) R> OVER - SPACES TYPE ;

: (D.#)         ( d1 n1 -- a1 n1 ) \ display d1 with n1 places behind DP
                >R <#              \ n1=negative will display'.' but no digits
                R> ?DUP            \ if not zero, then display places
                IF      0 MAX 0 ?DO # LOOP [char] . HOLD
                THEN    #S #> ;

: D.R.#         ( d1 n1 n2 -- )    \ print d1 in a field of n1 characters,
                                   \ display with n2 places behind DP
                SWAP >R (D.#) R> OVER - SPACES TYPE ;

: .R.1          ( n1 n2 -- )       \ print n1 right justified in field of n2
                0 SWAP 1 D.R.# ;   \ display with one place behind DP

\ BINARY double number display with commas

: RADIX:        ( n1 'name' -- )
                CREATE  , 2 cells , 0 , ['] _; !CSP ]
                DOES>   BASE @ >R
                        LCOUNT BASE ! EXECUTE   \ run headerless definition
                        R> BASE ! ;

2 RADIX: BUD,.R ( ud width -- )   UD,.R ;
2 RADIX: BU,.R  ( n1 width -- )   U,.R ;
2 RADIX: B.     ( n1 -- )       1 U,.R ;

: H.R           ( n1 n2 -- )    \ display n1 as a hex number right
                                \ justified in a field of n2 characters
                BASE @ >R HEX >R
                0 <# #S #> R> OVER - SPACES TYPE
                R> BASE ! ;

: H.N           ( n1 n2 -- )    \ display n1 as a HEX number of n2 digits
                BASE @ >R HEX >R
                0 <# R> 0 ?DO # LOOP #> TYPE
                R> BASE ! ;

: H.2           ( n1 -- ) 2 H.N ;               \ two digit HEX number
: H.4           ( n1 -- ) 4 H.N ;               \ four digit HEX number
: H.8           ( n1 -- ) 8 H.N ;               \ eight digit HEX number

0 value tot-malloc
0 value head-malloc

: malloc-init   ( -- )
    0 to tot-malloc
    0 to head-malloc ;

initialization-chain chain-add malloc-init

: malloc-release ( -- )         \ release all allocated memory
    begin   head-malloc
    while   head-malloc dup @ to head-malloc
      cell - dup @ negate +to tot-malloc
      _free
    repeat
    tot-malloc
    if      s"           bytes of memory left Allocated\n\n Press a key..." >r >r
      tot-malloc 0 <# #s #> r@ swap 10 min move
      r> r> "message
\      key drop
\      message-off
    then    ;

unload-chain chain-add-before malloc-release 

: link-malloc   ( pointer_to_malloc_mem -- )
    cell-                   \ backup to linked list
    head-malloc over !      \ link into malloc list
    to head-malloc  ;

: unlink-malloc ( pointer_to_malloc_mem -- f1 )
    cell- >r                        \ f1=FALSE=ok
    head-malloc dup r@ =            \ if its the top of the list
    if @ to head-malloc   FALSE     \ found and removed
    else
      begin   dup @ r@ =              \ found the entry?
        if      dup @ @ swap !  \ then unlink it
          r>drop          \ cleanup return stack
          FALSE           \ found and removed
          EXIT            \ stop looking
        then
        @ dup 0=
      until   drop
      TRUE                    \ failed to locate it
    then    r>drop ;

: allocate      ( n1 -- a1 f1 )                 \ ansi version of malloc
    dup 3 cells+ _allocate ?dup
    if over +to tot-malloc
      tuck !
      2 cells+ dup link-malloc
      FALSE
    else  drop here TRUE  then    ;                       \ -- f1 = true on error

: malloc        ( n1 -- a1 )                    \ allocate dynamic memory
    dup +to tot-malloc
    dup 3 cells+ _allocate ?dup 0= abort" Failed to allocate memory"
    tuck ! 2 cells+ dup link-malloc ;

: free          ( pointer_to_malloc_mem -- f1 ) \ release the memory pointer
                                                \ f1=TRUE=failed, f1=FALSE=ok
    dup unlink-malloc               \ first, delete from malloc list
    if  drop  TRUE
    else                            \ then actually release the mem
      2 cells- dup @ negate +to tot-malloc
      _free
      FALSE                   \ found and removed ok
    then    ;

: release       ( pointer_to_malloc_mem -- )
    free
    if s" Failed to Release Memory,  Press a KEY to continue..." "message
      key drop
\      message-off
    then    ;

: realloc       ( size pointer_to_malloc_mem -- pointer_to_new_mem flag )
    dup unlink-malloc               \ remove from list
    if  nip TRUE  EXIT   then
    over >r                         \ save requested size
    2 cells- dup @ negate +to tot-malloc
    r@ +to tot-malloc               \ new malloc-ed size
    swap 3 cells+ swap              \ three cell longer
    _resize ?dup
    if 2 cells+ r@ over 2 cells- !
      dup link-malloc
      false
    else true
    then r>drop ;             \ -- f1 = true if failed

: resize        ( a1 n1 -- a2 f1 )              \ ansi version of realloc
    swap realloc ;                  \ -- f1 = true on error

: .mallocs      ( -- )  \ display all dynamically allocated buffers
     head-malloc
     begin   ?dup
     while   dup cell+ cr ( tab ) ." Addr: " h.8 ."   Size: "
       dup cell- @ 10 u,.r ."  bytes"
       @
     repeat  ;

: ascii    char          state @ if postpone literal then ; immediate
: alt      char 4096  or state @ if postpone literal then ; immediate
: ctrl     char   31 and state @ if postpone literal then ; immediate

: _comment      \ char --
    ?loading @
    if begin source >in @ /string
         2 pick scan nip 0=
       while  refill 0= abort" EOF encountered in comment"
       repeat
    then parse 2drop ;

: comment       \ -<char>-
    char _comment ; immediate

true value multi-line?    \ we can have multiple line '(' comments

: (
    multi-line?
    IF [char] ) _comment
    ELSE [char] ) parse 2drop
    THEN ; immediate

: "comment      ( a1 n1 -- )    \ everything is a comment up to the string a1,n1
    ?loading @ 0= abort" Use this comment only while loading"
    2dup upper 2>r
    begin   bl word ?uppercase dup count 2r@ compare
    while   c@ 0=
      if refill 0= abort" EOF encountered in comment" then
    repeat  drop 2r> 2drop ;

\ Some comment words gleaned from various Forths, and C of course.

: /*            s" */"     "comment ; immediate         \ comment till */
: (*            s" *)"     "comment ; immediate         \ comment till *)
: DOC           s" ENDDOC" "comment ; immediate         \ comment till ENDDOC
\ : //            source >in ! drop   ; immediate         \ comment after //
: --            source >in ! drop   ; immediate         \ comment after --
: comment:      s" COMMENT;" "comment ; immediate

: defer@        ( -<name>- )    \ function currently in defered word name
    ' >IS
    state @
    if postpone literal postpone @
    else @ then ; immediate

: "path-only"   ( a1 n1 -- a2 n2 )      \ return path, minus final '/'
    2dup "to-pathend" nip - 2dup + 1- c@ [char] / =
    if 1- 0max then ;

: "minus-ext"   ( a1 n1 -- a2 n2 )      \ remove the file extention
    2dup [char] . scan nip - ;

: ".ext-only"   ( a1 n1 -- a1 n1 )      \ returns dotted file extention
    2dup "minus-ext" nip /string ;

: ?-/           ( a1 -- )       \ delete trailing '/' if present
    dup count + 1- c@ [char] / =    \ end in '/'?
    if -1 swap c+! else drop then ;

: ?+/           ( a1 -- )       \ append a '/' if not already present
    dup count + 1- c@ [char] / <>   \ end in '/'?
    if s" /" rot +place else drop  then ;

: ?+;           ( a1 -- )       \ append a ';' if not already present
    dup count + 1- c@ [char] ; <>   \ end in ';'?
    if s" ;" rot +place else drop  then ;

: ?+:           ( a1 -- )       \ append a [char] : if not already present
    dup count + 1- c@ [char] : <>   \ end in ':'?
    if s" :" rot +place else drop  then ;

: \-            ( -<word>- )            \ load line if word IS NOT defined
    defined nip
    if POSTPONE \ then ; immediate

: lacking postpone \- ; immediate

: \+            ( -<word>- )            \ load line if word IS defined
    defined nip 0=
    if POSTPONE \ then ; immediate

: having postpone \+ ; immediate

: C+PLACE       ( c1 a1 -- )    \ append char c1 to the counted string at a1
    tuck count + c! cincr ;

: ,"TEXT"       ( -<"text">- )  \ parse out quote delimited text and compile
                                \ it at here  NO EXTRA SPACES ARE NEEDED !!!
    source >in @ /string
    [char] " scan 1 /string                 \ skip past first quote
    2dup [char] " scan                      \ upto next quote
    2dup 2>r nip -                          \ parse out the string
    "CLIP" dup>r
    2dup [char] \ scan 2dup 2>r nip -       \ leading part of string
    here place                              \ save in BNAME
    2r> dup
    if over 1+ c@ upc [char] T =
      if 9 here c+place
        2 /string here  +place
        r> 1- >r
      else here +place
      then
    else 2drop
    then r> 1+ allot 0 c,
    source nip 2r> 1 /string nip - >in ! ;

: 2variable create 0 , 0 , ;

: 2constant
    create , ,
    does> 2@ ;

.( OK) cr