\ iterated interpretation
\ from the excellent articles in Forth Dimensions
\ by Wil Baden

.( Loading Wil Baden's MY, MACROS, (: ...)
internal

: split-at-char
    >r 2dup
    begin dup
    while over c@ r@ =
    0= while 1 /string
    repeat then
    r>drop dup>r 2swap r> - ;

2000 chars constant my-macros-size
my-macros-size pointer my-macros

: scan-item
    -rot 2>r
    begin @ dup
    while dup cell+ count 2r@ compare 0=
    until cell+
    then 2r> 2drop ;

: my-macros-enough
    over 1+ chars over + my-macros my-macros-size + u>
    abort" My macros full" ;

: my-new-macro
    my-macros @
    dup 0= if drop my-macros cell+
    else cell+ count chars + count chars + aligned
    then
    dup my-macros 2dup @ swap ! ! cell+ ;

: my-macro
    my-new-macro >r
    bl word ?uppercase count
    r@ my-macros-enough place
    char parse r> count chars + my-macros-enough place ;

external

: MACRO
    create immediate char string,
    does> count
      begin [char] \ split-at-char 2swap 2>r
        evaluate
      2r@ nip while
        bl word count evaluate
        2r> 1 /string
      repeat 2r> 2drop ;

macro ??   " if \ then"
macro THE  " [ also \ ] \ [ previous ]"
macro TH   " cells+"
macro 'TH  " \ +cells"
macro FOR  " begin ?dup while 1- >r"
macro NEXT " r> repeat"

: MY
    bl word ?uppercase count
    2dup s" MACRO" compare 0=
    if 2drop my-macro exit then
    my-macros scan-item dup 0= abort" Not a My macro"
    count chars + count evaluate ; immediate

: CLEAR-MY-MACROS 0 my-macros ! ;

internal

: next-word
    begin bl word count dup 0=
    while refill
    while 2drop
    repeat then ;

160 constant agenda-limit
create Agenda agenda-limit chars allot

clear-my-macros
my macro agenda-end " agenda agenda-limit r@ - chars + "
my macro agenda-switch " agenda count chars + "

external

: (:
    [char] | parse agenda place
    [char] | parse >r my agenda-end r@ move
    begin next-word dup
    while 2dup s" :)" compare
    while 2dup s" ^" compare 0=
      if 2drop [char] ^ parse then
      dup agenda c@ + r@ + agenda-limit >=
      abort" agenda-limit is too small"
      tuck my agenda-switch swap move
      my agenda-switch over chars +
      my agenda-end swap r@ move
      agenda count rot +
      2dup chars + r@ swap >r +
      evaluate
      r> my agenda-end r@ move
    repeat then
    r>drop 2drop ; immediate

module

: CHECKED abort" (File Access Error)";
: OPENED open-file abort" Can't open" ;
: CLOSED close-file abort" Can't close" ;

.( OK) cr

clear-my-macros
